/**
 * \file
 *
 * \brief AVR XMEGA EpUSARTײފg
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "usart_xmegae.h"

/*
 * XMEGAُ̧C
 * USART.CTRLC ޯĎՕޯĈʒu
 */
#ifndef USART_UCPHA_bm
#  define USART_UCPHA_bm 0x02
#endif
#ifndef USART_DORD_bm
#  define USART_DORD_bm 0x04
#endif

/**
 * \brief XMEGA EpɓlRS232USART
 *
 * ̊֐usart_rs232_options_t`Ԑݒ\̂CPUggpRS232
 * USARTPʕ܂Busart_init_rs232()ƔׂāÅ֐͒P
 * AڰъJnoAް/Aڰђ̂悤XMEGA EL@\ւ̱
 * ^܂B
 *
 * \param  usart USARTPʕ
 * \param  opt   RS232`ԐݒCӑI
 *
 * \retval true  ꍇ
 * \retval false sꍇ(ްڰČvZňُ)
 */
bool usart_xmegae_init_rs232(USART_t *usart,
		const usart_xmegae_rs232_options_t *opt)
{
	bool result;

	sysclk_enable_peripheral_clock(usart);

	usart_set_mode(usart, USART_CMODE_ASYNCHRONOUS_gc);
	usart_format_set(usart, opt->charlength, opt->paritytype,
			opt->stopbits);
	result = usart_set_baudrate(usart, opt->baudrate, sysclk_get_per_hz());

	/* KvȂ΁A/`Ԑݒ */
	if (opt->encoding_stream != USART_LUTACT_OFF_gc) {
		usart_xmegae_encoding(usart, opt->encoding_type,
				opt->encoding_stream);
	}

	usart_sfden(usart, opt->start_frame_detection);
	usart_onewire(usart, opt->one_wire);

	/* XCLPECgpׂĂ`Ԑݒ */
	if (opt->pec_length) {
		xcl_enable(XCL_SYNCHRONOUS);
#ifdef USARTC0
		if ((uint16_t)usart == (uint16_t)&USARTC0) {
			xcl_port(PC);
		}
#endif
#ifdef USARTD0
		if ((uint16_t)usart == (uint16_t)&USARTD0) {
			xcl_port(PD);
		}
#endif
		if (opt->pec_length > 16) {
			xcl_tc_type(PEC01);
		} else {
			xcl_tc_type(BTC0PEC2);
		}

		xcl_pec_set_lenght(opt->pec_length - 1);
		usart_xmegae_pec_action(usart, opt->pec_action);
	}

	if (opt->one_wire == false) {
		usart_tx_enable(usart);
	}

	usart_rx_enable(usart);

	return result;
}

/**
 * \brief PUSARTPʕް𑗏o
 *
 * ̊֐USARTPʕpްo͂܂B
 *
 * \param  usart USARTPʕ
 * \param  c     ׂް
 *
 * \return STATUS_OK
 */
enum status_code usart_putchar_onewire(USART_t *usart, uint8_t c)
{
	port_pin_t tx_pin;
	while (usart_data_register_is_empty(usart) == false) {
	}

#ifdef USARTC0
	if ((uint16_t)usart == (uint16_t)&USARTC0) {
		tx_pin = IOPORT_CREATE_PIN(PORTC, 2);
		ioport_configure_port_pin(ioport_pin_to_port(tx_pin),
				ioport_pin_to_mask(tx_pin),
				IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH);
	}
#endif
#ifdef USARTD0
	if ((uint16_t)usart == (uint16_t)&USARTD0) {
		tx_pin = IOPORT_CREATE_PIN(PORTD, 2);
		ioport_configure_port_pin(ioport_pin_to_port(tx_pin),
				ioport_pin_to_mask(tx_pin),
				IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH);
	}
#endif
	usart_tx_enable(usart);
	usart_rx_disable(usart);
	(usart)->DATA = c;
	while (!usart_tx_is_complete(usart)) {
	}
	usart_clear_tx_complete(usart);
	usart_rx_enable(usart);
	usart_tx_disable(usart);
	ioport_configure_port_pin(ioport_pin_to_port(tx_pin),
			ioport_pin_to_mask(tx_pin),
			IOPORT_DIR_INPUT | IOPORT_PULL_UP);
	return STATUS_OK;
}

/**
 * \brief XMEGA EpSPI呕uUSART
 *
 * ̊֐usart_xmegae_spi_options_t`Ԑݒ\̂CPUggpSPI
 * uUSARTPʕ܂Busart_init_spi()ƔׂāÅ֐ް
 * /Ɖڰђ̂悤XMEGA EL@\ւ̱^܂B
 *
 * \param  usart USARTPʕ
 * \param  opt   SPI呕u`ԐݒCӑI
 */
void usart_xmegae_init_spi(USART_t *usart,
		const usart_xmegae_spi_options_t *opt)
{
	ioport_pin_t sck_pin;
	bool invert_sck;

	sysclk_enable_peripheral_clock(usart);

	usart_rx_disable(usart);

	/* SCKo߰ĂINVENޯĂpĸۯɐ`Ԑݒ */
	invert_sck = (opt->spimode == 2) || (opt->spimode == 3);
	UNUSED(invert_sck);

#ifdef USARTC0
	if ((uint16_t)usart == (uint16_t)&USARTC0) {
		sck_pin = IOPORT_CREATE_PIN(PORTC, 1);
	}
#endif
#ifdef USARTC1
	if ((uint16_t)usart == (uint16_t)&USARTC1) {
		sck_pin = IOPORT_CREATE_PIN(PORTC, 5);
	}
#endif
#ifdef USARTD0
	if ((uint16_t)usart == (uint16_t)&USARTD0) {
		sck_pin = IOPORT_CREATE_PIN(PORTD, 1);
	}
#endif
#ifdef USARTD1
	if ((uint16_t)usart == (uint16_t)&USARTD1) {
		sck_pin = IOPORT_CREATE_PIN(PORTD, 5);
	}
#endif
#ifdef USARTE0
	if ((uint16_t)usart == (uint16_t)&USARTE0) {
		sck_pin = IOPORT_CREATE_PIN(PORTE, 1);
	}
#endif
#ifdef USARTE1
	if ((uint16_t)usart == (uint16_t)&USARTE1) {
		sck_pin = IOPORT_CREATE_PIN(PORTE, 5);
	}
#endif
#ifdef USARTF0
	if ((uint16_t)usart == (uint16_t)&USARTF0) {
		sck_pin = IOPORT_CREATE_PIN(PORTF, 1);
	}
#endif
#ifdef USARTF1
	if ((uint16_t)usart == (uint16_t)&USARTF1) {
		sck_pin = IOPORT_CREATE_PIN(PORTF, 5);
	}
#endif

	/* USARTo݌`Ԑݒ */
	ioport_set_pin_dir(sck_pin, IOPORT_DIR_OUTPUT);
	ioport_set_pin_mode(sck_pin,
			IOPORT_MODE_TOTEM | (invert_sck? IOPORT_MODE_INVERT_PIN : 0));
	ioport_set_pin_level(sck_pin, IOPORT_PIN_LEVEL_HIGH);

	usart_set_mode(usart, USART_CMODE_MSPI_gc);

	if (opt->spimode == 1 || opt->spimode == 3) {
		usart->CTRLC |= USART_UCPHA_bm;
	} else {
		usart->CTRLC &= ~USART_UCPHA_bm;
	}
	if (opt->data_order) {
		(usart)->CTRLC |= USART_DORD_bm;
	} else {
		(usart)->CTRLC &= ~USART_DORD_bm;
	}

	usart_spi_set_baudrate(usart, opt->baudrate, sysclk_get_per_hz());

	/* KvȂ΁A/`Ԑݒ */
	if (opt->encoding_stream != USART_LUTACT_OFF_gc) {
		usart_xmegae_encoding(usart, opt->encoding_type,
				opt->encoding_stream);
	}

	/* XCLPECgpׂĂ`Ԑݒ */
	if (opt->pec_length) {
		xcl_enable(XCL_SYNCHRONOUS);
#ifdef USARTC0
		if ((uint16_t)usart == (uint16_t)&USARTC0) {
			xcl_port(PC);
		}
#endif
#ifdef USARTD0
		if ((uint16_t)usart == (uint16_t)&USARTD0) {
			xcl_port(PD);
		}
#endif
		if (opt->pec_length > 16) {
			xcl_tc_type(PEC01);
		} else {
			xcl_tc_type(BTC0PEC2);
		}

		xcl_pec_set_lenght(opt->pec_length - 1);
		usart_xmegae_pec_action(usart, opt->pec_action);
	}

	usart_tx_enable(usart);
	usart_rx_enable(usart);
}
